<?php
/**
 * Created by PhpStorm.
 * User: erikasantos
 * Date: 08/04/14
 * Time: 13:44
 */

namespace Geral\Facade;

class Estrutura {

    const WINDOW = 'gpe_wnd_estrutura_wzd';
    const TAB    = 'gpe_tab_estrutura_wzd';

    const FIELDGROUP_GERAL     = 'gpe_geral';
    const FIELDGROUP_ESTRUTURA = 'gpe_estrutura';
    const FIELDGROUP_FISCAIS   = 'gpe_fiscais';

    const FIELD_NMRAZSOCESTRUT  = 'NMRAZSOCESTRUT';
    const FIELD_NMFANTASIA      = 'NMFANTASIA';
    const FIELD_DTINIVIGENCIA   = 'DTINIVIGENCIA';
    const FIELD_NRCALENDARIO    = 'NRCALENDARIO';
    const FIELD_CDCNPJESTRUT    = 'CDCNPJESTRUT';
    const FIELD_NRTIPOESTRUTURA = 'NRTIPOESTRUTURA';
    const FIELD_CDSINDICAL      = 'CDSINDICAL';
    const FIELD_DTBASESINDICAL  = 'DTBASESINDICAL';
    const FIELD_IDTIPOEMPR      = 'IDTIPOEMPR';
    const FIELD_IDOPTSIMPLES    = 'IDOPTSIMPLES';
    const FIELD_IDPARTICIPAT    = 'IDPARTICIPAT';
    const FIELD_CDNATUJURI      = 'CDNATUJURI';
    const FIELD_CDCNAE          = 'CDCNAE';
    const FIELD_CDFPAS          = 'CDFPAS';

    public static function verificaCamposPreenchidos() {
        self::setContextVars();

        $camposRequeridos = self::getCamposRequeridos();

        $nullEncontrado = 0;
        foreach($camposRequeridos as $value) {
            $valorCampo = tk_get_field_value($value);
            if (!$valorCampo) {
                tk_validate_data(true);
                $nullEncontrado++;
            }
        }

        if (!$nullEncontrado) {
            tk_open_wizard_stage('ENDERECOPARC_WZD', 'gpe_estrutura_wzd');
        }
    }

    /**
     * Metodo 1003169 no metadados
     * Torna invisiveis os campos que nao sao especificos para todas as estruturas.
     */
    public static function trataEstadoCampos() {
        $nrtipoestrutura = tk_get_field_value('NRTIPOESTRUTURA');
        $nrorg = \Geral\Util\Ambiente::getNrorgTrabalho();
        /** @var $paramorg \Folha\Entities\GpeParamorg */
        $paramorg = \Folha\Entities\GpeParamorg::findOneByNrorg($nrorg);
        $nrtipoestruturaLegal = $paramorg->getNrtpestrutlegal();
        switch($nrtipoestrutura) {

            case 1:
                $required_fields = array(
                    self::FIELD_DTINIVIGENCIA, self::FIELD_IDTIPOEMPR, self::FIELD_CDCNPJESTRUT,
                    self::FIELD_NRCALENDARIO, self::FIELD_NMFANTASIA, self::FIELD_NMRAZSOCESTRUT,
                    self::FIELD_IDOPTSIMPLES, self::FIELD_IDPARTICIPAT
                );
                foreach ($required_fields as $requiredField) {
                    tk_set_visible_field($requiredField);
                    tk_set_field_required($requiredField);
                }


                tk_set_invisible_field(self::FIELD_CDSINDICAL);
                tk_set_invisible_field(self::FIELD_DTBASESINDICAL);

                tk_set_invisible_fieldgroup(self::FIELDGROUP_FISCAIS);
                tk_set_visible_fieldgroup(self::FIELDGROUP_ESTRUTURA);
                tk_set_uncollapsed_fieldgroup(self::FIELDGROUP_ESTRUTURA);

                tk_set_field_not_required(self::FIELD_CDSINDICAL);
                tk_set_field_not_required(self::FIELD_DTBASESINDICAL);
                break;

            case 2:

                $disable_fields = array(self::FIELD_IDTIPOEMPR,self::FIELD_CDSINDICAL,self::FIELD_IDOPTSIMPLES,
                    self::FIELD_DTBASESINDICAL, self::FIELD_NRCALENDARIO, self::FIELD_IDPARTICIPAT);
                foreach ($disable_fields as $disibleField) {
                    tk_set_invisible_field($disibleField);
                    tk_set_field_not_required($disibleField);
                }

                $required_fields = array(self::FIELD_NRTIPOESTRUTURA, self::FIELD_DTINIVIGENCIA, self::FIELD_NMFANTASIA,
                    self::FIELD_CDCNPJESTRUT, self::FIELD_NMRAZSOCESTRUT);

                foreach ($required_fields as $requiredField) {
                    tk_set_visible_field($requiredField);
                    tk_set_field_required($requiredField);
                }

                tk_set_invisible_fieldgroup(self::FIELDGROUP_FISCAIS);
                tk_set_visible_fieldgroup(self::FIELDGROUP_ESTRUTURA);
                tk_set_uncollapsed_fieldgroup(self::FIELDGROUP_ESTRUTURA);

                break;

            case 7:
                $required_fields = array(
                    self::FIELD_DTINIVIGENCIA, self::FIELD_IDTIPOEMPR, self::FIELD_CDCNPJESTRUT,
                    self::FIELD_NRCALENDARIO, self::FIELD_NMFANTASIA, self::FIELD_NMRAZSOCESTRUT,
                    self::FIELD_IDOPTSIMPLES, self::FIELD_IDPARTICIPAT
                );
                foreach ($required_fields as $requiredField) {
                    tk_set_visible_field($requiredField);
                    tk_set_field_required($requiredField);
                }


                tk_set_invisible_field(self::FIELD_CDSINDICAL);
                tk_set_invisible_field(self::FIELD_DTBASESINDICAL);

                tk_set_invisible_fieldgroup(self::FIELDGROUP_FISCAIS);
                tk_set_visible_fieldgroup(self::FIELDGROUP_ESTRUTURA);
                tk_set_uncollapsed_fieldgroup(self::FIELDGROUP_ESTRUTURA);

                tk_set_field_not_required(self::FIELD_CDSINDICAL);
                tk_set_field_not_required(self::FIELD_DTBASESINDICAL);
                break;

            case 10:
                $required_fields = array(
                    self::FIELD_DTINIVIGENCIA, self::FIELD_CDSINDICAL, self::FIELD_DTBASESINDICAL,
                    self::FIELD_CDCNPJESTRUT
                );

                foreach ($required_fields as $requiredField) {
                    tk_set_visible_field($requiredField);
                    tk_set_field_required($requiredField);
                }

                tk_set_invisible_field(self::FIELD_IDOPTSIMPLES);
                tk_set_invisible_field(self::FIELD_NRCALENDARIO);
                tk_set_invisible_field(self::FIELD_IDTIPOEMPR);
                tk_set_invisible_field(self::FIELD_IDPARTICIPAT);
                tk_set_invisible_fieldgroup(self::FIELDGROUP_FISCAIS);
                tk_set_uncollapsed_fieldgroup(self::FIELDGROUP_ESTRUTURA);
                tk_set_visible_fieldgroup(self::FIELDGROUP_ESTRUTURA);

                tk_set_field_not_required(self::FIELD_IDOPTSIMPLES);
                tk_set_field_not_required(self::FIELD_NRCALENDARIO);
                tk_set_field_not_required(self::FIELD_IDTIPOEMPR);
                tk_set_field_not_required(self::FIELD_IDPARTICIPAT);

                break;
            case $nrtipoestruturaLegal:
                $required_fields = array(
                    self::FIELD_DTINIVIGENCIA, self::FIELD_NMFANTASIA, self::FIELD_NMRAZSOCESTRUT,
                    self::FIELD_NRCALENDARIO,  self::FIELD_CDCNPJESTRUT
                );

                foreach ($required_fields as $requiredField) {
                    tk_set_visible_field($requiredField);
                    tk_set_field_required($requiredField);
                }


                tk_set_invisible_field(self::FIELD_CDSINDICAL);
                tk_set_invisible_field(self::FIELD_DTBASESINDICAL);
                tk_set_invisible_field(self::FIELD_IDPARTICIPAT);
                tk_set_invisible_field(self::FIELD_IDTIPOEMPR);
                tk_set_visible_fieldgroup(self::FIELDGROUP_FISCAIS);
                tk_set_uncollapsed_fieldgroup(self::FIELDGROUP_ESTRUTURA);
                tk_set_uncollapsed_fieldgroup(self::FIELDGROUP_FISCAIS);
                tk_set_visible_fieldgroup(self::FIELDGROUP_ESTRUTURA);

                tk_set_field_not_required(self::FIELD_IDTIPOEMPR);
                tk_set_field_not_required(self::FIELD_IDPARTICIPAT);
                tk_set_field_not_required(self::FIELD_CDSINDICAL);
                tk_set_field_not_required(self::FIELD_DTBASESINDICAL);

                break;
            default:
                $required_fields = array(self::FIELD_NRTIPOESTRUTURA, self::FIELD_DTINIVIGENCIA, self::FIELD_NMFANTASIA);

                tk_set_invisible_fieldgroup(self::FIELDGROUP_FISCAIS);
                tk_set_uncollapsed_fieldgroup(self::FIELDGROUP_GERAL);
                tk_set_invisible_fieldgroup(self::FIELDGROUP_ESTRUTURA);

                $disable_fields = array(self::FIELD_CDCNPJESTRUT,self::FIELD_IDTIPOEMPR,self::FIELD_CDSINDICAL,self::FIELD_IDOPTSIMPLES,
                    self::FIELD_DTBASESINDICAL, self::FIELD_NMRAZSOCESTRUT, self::FIELD_NRCALENDARIO, self::FIELD_IDPARTICIPAT);
                foreach ($disable_fields as $disibleField) {
                    tk_set_invisible_field($disibleField);
                    tk_set_field_not_required($disibleField);
                }

                if($nrtipoestrutura != 3 && $nrtipoestrutura != 4 && $nrtipoestrutura != 6 &&
                   $nrtipoestrutura != 8 && $nrtipoestrutura != 12 && $nrtipoestrutura != ""){
                    tk_set_visible_field(self::FIELD_CDCNPJESTRUT);
                    tk_set_visible_fieldgroup(self::FIELDGROUP_ESTRUTURA);
                    tk_set_uncollapsed_fieldgroup(self::FIELDGROUP_ESTRUTURA);
                    $required_fields[] = self::FIELD_CDCNPJESTRUT;
                    tk_set_field_required(self::FIELD_CDCNPJESTRUT);
                }

        }

        tk_set_context_vars('CAMPOS_REQUERIDOS', self::WINDOW, $required_fields);
    }

    public static function whereParcnegocio(){
        $nrparcnegocio = tk_get_context_vars('NRPARCNEGOCIO', 'ger_estrutura');
        if ($nrparcnegocio == null){
            $where = '1 = 2';
        } else{
            $where = 'PARCNEGOCIO.NRPARCNEGOCIO = '.$nrparcnegocio.'';
        }
        return $where;
    }

    private static function setContextVars() {
        tk_set_context_vars(self::FIELD_CDFPAS, self::WINDOW, tk_get_field_value(self::FIELD_CDFPAS));
        tk_set_context_vars(self::FIELD_CDCNAE, self::WINDOW, tk_get_field_value(self::FIELD_CDCNAE));
        tk_set_context_vars(self::FIELD_CDNATUJURI, self::WINDOW, tk_get_field_value(self::FIELD_CDNATUJURI));
        tk_set_context_vars(self::FIELD_IDPARTICIPAT, self::WINDOW, tk_get_field_value(self::FIELD_IDPARTICIPAT));
        tk_set_context_vars(self::FIELD_IDOPTSIMPLES, self::WINDOW, tk_get_field_value(self::FIELD_IDOPTSIMPLES));
        tk_set_context_vars(self::FIELD_IDTIPOEMPR, self::WINDOW, tk_get_field_value(self::FIELD_IDTIPOEMPR));
        tk_set_context_vars(self::FIELD_DTBASESINDICAL, self::WINDOW, tk_get_field_value(self::FIELD_DTBASESINDICAL));
        tk_set_context_vars(self::FIELD_CDSINDICAL, self::WINDOW, tk_get_field_value(self::FIELD_CDSINDICAL));
        tk_set_context_vars(self::FIELD_NRTIPOESTRUTURA, self::WINDOW, tk_get_field_value(self::FIELD_NRTIPOESTRUTURA));
        tk_set_context_vars(self::FIELD_CDCNPJESTRUT, self::WINDOW, tk_get_field_value(self::FIELD_CDCNPJESTRUT));
        tk_set_context_vars(self::FIELD_NRCALENDARIO, self::WINDOW, tk_get_field_value(self::FIELD_NRCALENDARIO));
        tk_set_context_vars(self::FIELD_DTINIVIGENCIA, self::WINDOW, tk_get_field_value(self::FIELD_DTINIVIGENCIA));
        tk_set_context_vars(self::FIELD_NMFANTASIA, self::WINDOW, tk_get_field_value(self::FIELD_NMFANTASIA));
        tk_set_context_vars(self::FIELD_NMRAZSOCESTRUT, self::WINDOW, tk_get_field_value(self::FIELD_NMRAZSOCESTRUT));
    }

    public static function getNomeFantasia() {
        return tk_get_context_vars(self::FIELD_NMFANTASIA, self::WINDOW);
    }

    public static function getRazaoSocial() {
        return tk_get_context_vars(self::FIELD_NMRAZSOCESTRUT, self::WINDOW);
    }

    public static function getDataInicioVigencia() {
        return tk_get_context_vars(self::FIELD_DTINIVIGENCIA, self::WINDOW);
    }

    public static function getNumeroCalendario() {
        return tk_get_context_vars(self::FIELD_NRCALENDARIO, self::WINDOW);
    }

    public static function getCnpj() {
        return tk_get_context_vars(self::FIELD_CDCNPJESTRUT, self::WINDOW);
    }

    public static function getNumeroTipoEstrutura() {
        return tk_get_context_vars(self::FIELD_NRTIPOESTRUTURA, self::WINDOW);
    }

    public static function getCodigoSindical() {
        return tk_get_context_vars(self::FIELD_CDSINDICAL, self::WINDOW);
    }

    public static function getDataBaseSindical() {
        return tk_get_context_vars(self::FIELD_DTBASESINDICAL, self::WINDOW);
    }

    /**
     * Campo representa um check constraint CKC_IDTIPOEMPR.
     * Valores: (null, 1, 2, 3, 4)
     *
     * @return null
     */
    public static function getCkcTipoEmpresa() {
        return tk_get_context_vars(self::FIELD_IDTIPOEMPR, self::WINDOW);
    }

    /**
     * Campo representa um check constraint.
     * Valores: ('S', 'N')
     *
     * @return null
     */
    public static function getCkcOpcaoSIMPLES() {
        return tk_get_context_vars(self::FIELD_IDOPTSIMPLES, self::WINDOW);
    }

    /**
     * Campo representa um check constraint.
     * Valores: ('S', 'N')
     *
     * @return null
     */
    public static function getCkcParticipaPAT() {
        return tk_get_context_vars(self::FIELD_IDPARTICIPAT, self::WINDOW);
    }

    public static function getNaturezaJuridica() {
        return tk_get_context_vars(self::FIELD_CDNATUJURI, self::WINDOW);
    }

    public static function getCodigoCNAE() {
        return tk_get_context_vars(self::FIELD_CDCNAE, self::WINDOW);
    }

    public static function getCodigoFPAS() {
        return tk_get_context_vars(self::FIELD_CDFPAS, self::WINDOW);
    }

    public static function getCamposRequeridos() {
        return tk_get_context_vars('CAMPOS_REQUERIDOS', self::WINDOW);
    }

    public static function geraEstruturaFilial(){
        \Geral\Entities\Estruturam::geraEstruturaFilial();
    }

}