/* Sistemas Integrados TEKNISA
Nome:

@C:\web_542\sql\end_conv\oracle\clientes\lsg\0006_LSGSTPO_LSG_TRAB_IMPOSTO_ENTRADA.SQL

Descrio:
Rotina para gerar impostos nas tabelas de trabalho

*/

CREATE OR REPLACE PROCEDURE LSG_TRAB_IMPOSTO_ENTRADA (
   P_CDFILIAL    IN  NOTAFISCAL.CDFILIAL%TYPE,
   P_NRLANCTONF  IN  NOTAFISCAL.NRLANCTONF%TYPE,
   P_NRLANCESTQ  IN  LANCTOESTOQ.NRLANCESTQ%TYPE,
   P_VRNOTAFISC  OUT NUMBER)
AS
   V_INCITEMP     VARCHAR2(14);
   V_ALIQTEMP     VARCHAR2(14);
   V_CSTTEMP      VARCHAR2(14);
   V_PAISORIG     VARCHAR2(04);
   V_ESTAORIG     VARCHAR2(02);
   V_MUNIORIG     VARCHAR2(04);
   V_PAISDEST     VARCHAR2(04);
   V_ESTADEST     VARCHAR2(02);
   V_MUNIDEST     VARCHAR2(04);
   V_IDTRIMPSTII  VARCHAR2(01);
   V_CDGRUPOFISC  VARCHAR2(03);
   V_IDINTEREST   VARCHAR2(01);

   V_VRNOTAFISC   NUMBER;
   V_LIQUIITEM    NUMBER;
   V_MINBCPROD    NUMBER;
   V_NRALIQTEMP   NUMBER;
   V_PARDEDTMP    NUMBER;
   V_PREDBCTMP    NUMBER;
   V_ALIQUTMP     NUMBER;
   V_IMPOSTOIT    NUMBER;
   V_ALIQINFO     NUMBER;
   V_IMPOSINFO    NUMBER;
   V_VRIMPOSTOST  NUMBER;
   V_TAXABASECALC NUMBER;
   V_TAXAALIQUOTA NUMBER;
   V_TAXAALIQINFO NUMBER;
   V_TAXABCSUBSTR NUMBER;
   V_BASECALCIT   NUMBER;
   V_PBCSUBTRIB   NUMBER;
   V_LIQUIDOPROD  NUMBER;

BEGIN

   FOR C_NOTA IN (SELECT DISTINCT NF.CDFILIAL,    NF.NRLANCTONF,  NF.CDEMPRESA,
                                  NF.CDINSCESTA,  NF.CDFORNECED,  NF.CDFILIRECE,
                                  NF.DTENTRSAID,  NF.CDSERIEENTR, NF.NRINSJURNF,
                                  NF.IDORIGDESTNF, NF.CDTIPOOPER, NF.CDFILIEMIT,
                                  NF.NRNOTAFISC
                    FROM NOTAFISCAL NF
                   WHERE NF.CDFILIAL   = P_CDFILIAL
                     AND NF.NRLANCTONF = P_NRLANCTONF)  LOOP

      CONSULTA_GRUPOFISCAL(C_NOTA.IDORIGDESTNF, C_NOTA.CDFORNECED, '','E', C_NOTA.CDTIPOOPER, V_CDGRUPOFISC);

      FOR C_ITEM IN (SELECT R.CDARVPROD, I.VRDESCITEM, I.VRTOTAITEM,
                            I.NRSEQITPROD, I.CDPRODUTO
                       FROM ITEMPRODUTO I, PRODUTO R
                      WHERE I.CDFILIAL   = C_NOTA.CDFILIAL
                        AND I.NRLANCTONF = C_NOTA.NRLANCTONF
                        AND I.CDPRODUTO  = R.CDPRODUTO) LOOP

         V_INCITEMP := C_NOTA.CDFILIAL||C_NOTA.NRLANCTONF;
         V_ALIQTEMP := C_NOTA.CDFILIAL||C_NOTA.NRLANCTONF;
         V_CSTTEMP  := C_NOTA.CDFILIAL||C_NOTA.NRLANCTONF;

         IF C_NOTA.IDORIGDESTNF = 'L' THEN
            SELECT MAX(CDPAIS), MAX(SGESTADO), MAX(CDMUNICIPIO)
              INTO V_PAISORIG, V_ESTAORIG, V_MUNIORIG
              FROM ENDEFILI
             WHERE (CDFILIAL     = C_NOTA.CDFILIRECE)
               AND (IDTPENDEFILI = 'P');

         ELSE
            SELECT MAX(CDPAIS), MAX(SGESTADO), MAX(CDMUNICIPIO)
              INTO V_PAISORIG, V_ESTAORIG, V_MUNIORIG
              FROM ENDEFORN
             WHERE (CDFORNECED   = C_NOTA.CDFORNECED) AND
                   (IDTPENDEFORN = 'P');

         END IF;

         SELECT MAX(CDPAIS), MAX(SGESTADO), MAX(CDMUNICIPIO)
           INTO V_PAISDEST, V_ESTADEST, V_MUNIDEST
           FROM INSCRESTAD
          WHERE (CDEMPRESA  = C_NOTA.CDEMPRESA) AND
                (CDINSCESTA = C_NOTA.CDINSCESTA);

         V_LIQUIDOPROD := C_ITEM.VRTOTAITEM - C_ITEM.VRDESCITEM;

         CALCULO_MINBCPRODUTO(C_NOTA.CDEMPRESA, C_NOTA.CDTIPOOPER,C_NOTA.CDINSCESTA, 'E', V_PAISORIG, V_ESTAORIG,
                              C_ITEM.CDPRODUTO, NULL, C_NOTA.DTENTRSAID,C_NOTA.CDFILIAL, C_NOTA.NRLANCTONF,
                              C_ITEM.NRSEQITPROD, V_MINBCPROD);

         IF V_MINBCPROD = 0 THEN
            V_LIQUIITEM := C_ITEM.VRTOTAITEM - C_ITEM.VRDESCITEM;
         ELSE
            V_LIQUIITEM := V_MINBCPROD - C_ITEM.VRDESCITEM;
         END IF;

         V_IDINTEREST := 'N';
         IF (V_PAISDEST = V_PAISORIG) AND (V_ESTADEST <> V_ESTAORIG) THEN
            V_IDINTEREST := 'S';
         END IF;

         CONSULTA_CST('E', C_NOTA.CDEMPRESA, C_ITEM.CDARVPROD,C_NOTA.CDINSCESTA, C_NOTA.CDTIPOOPER, C_NOTA.CDFILIAL,C_NOTA.NRLANCTONF, V_CDGRUPOFISC);

         CONSULTA_INCIDENCIA('E', C_NOTA.CDEMPRESA, C_ITEM.CDARVPROD,C_NOTA.CDINSCESTA, C_NOTA.CDTIPOOPER, C_NOTA.CDFILIAL,
                              C_NOTA.NRLANCTONF, V_CDGRUPOFISC);

         FOR C_INCIDENCIA IN (SELECT CDIMPOTEMP, MAX(CDFISCTEMP) AS CDFISCTEMP,
                                     MAX(IDTRATIMPTMP) AS IDTRATIMPTMP,
                                     MAX(IDCONSISTENT) AS IDCONSISTENT, MAX(NVL(IDUTMUNIORIG, 'N')) AS
                                     IDUTMUNIORIG,
                                     MAX(IDIMPORECUP)  AS IDIMPORECUP,
                                     MAX(NVL(IDPREIMPENTR, 'N')) AS IDPREIMPENTR,
                                     MAX(IDORGARRECAD) AS IDORGARRECAD
                                FROM INCITEMP IT, IMPOSTO IP
                               WHERE (IT.NRINCITEMP = V_INCITEMP)
                                 AND (IP.CDIMPOSTO = IT.CDIMPOTEMP)
                                 AND (IP.IDPRODNOTA = 'P')
                               GROUP BY CDIMPOTEMP) LOOP

            IF C_INCIDENCIA.IDUTMUNIORIG = 'D' THEN
               /* CONSIDERA O MUNICIPIO DE DESTINO */
               CONSULTA_ALIQUOTA(C_INCIDENCIA.CDIMPOTEMP, 'E',C_NOTA.CDEMPRESA, C_ITEM.CDARVPROD, C_NOTA.CDINSCESTA, V_PAISORIG,
                                 V_ESTAORIG, V_PAISDEST, V_ESTADEST,V_MUNIDEST, V_LIQUIITEM, C_NOTA.DTENTRSAID,
                                 C_NOTA.CDFILIAL,C_NOTA.NRLANCTONF, V_CDGRUPOFISC);
            ELSE
              /* CONSIDERA O MUNICIPIO DE ORIGEM */
               CONSULTA_ALIQUOTA(C_INCIDENCIA.CDIMPOTEMP, 'E',C_NOTA.CDEMPRESA, C_ITEM.CDARVPROD, C_NOTA.CDINSCESTA, V_PAISORIG,
                                 V_ESTAORIG, V_PAISDEST, V_ESTADEST,V_MUNIORIG, V_LIQUIITEM, C_NOTA.DTENTRSAID,
                                 C_NOTA.CDFILIAL,C_NOTA.NRLANCTONF, V_CDGRUPOFISC);
            END IF;

            V_NRALIQTEMP  := 0;
            V_PARDEDTMP   := 0;
            V_PREDBCTMP   := 0;
            V_ALIQUTMP    := 0;
            V_IMPOSTOIT   := 0;
            V_ALIQINFO    := 0;
            V_IMPOSINFO   := 0;
            V_VRIMPOSTOST := 0;

            SELECT NVL(MAX(NRALIQTEMP),0), NVL(MAX(VRPARDEDTMP),0),
                   NVL(MAX(VRPREDBCTMP),0), NVL(MAX(VRALIQUTMP),0),
                   NVL(MAX(VRPBCSTTMP),0), NVL(MAX(IDTRIMPSTTMP), '0')
              INTO V_NRALIQTEMP, V_PARDEDTMP, V_PREDBCTMP, V_ALIQUTMP,
                   V_PBCSUBTRIB, V_IDTRIMPSTII
              FROM ALIQTEMP
             WHERE (NRALIQTEMP = V_ALIQTEMP);


            V_TAXABASECALC := (100 - V_PREDBCTMP)/100;
            V_TAXAALIQUOTA := (V_ALIQUTMP/100);
            V_TAXAALIQINFO := (V_ALIQINFO/100);
            V_TAXABCSUBSTR := 1 + (V_PBCSUBTRIB/100);
            V_BASECALCIT := V_LIQUIITEM * V_TAXABASECALC;

            INSERT INTO TRABITPROIMPOS(
                   CDFILIMPOIT, NRLANCIMPOIT, NRSEQIMPOIT, CDIMPOSTOIT, CDFISCIMPOIT,
                   VRCONTIMPOIT, VRPDEDIMPOIT, VRALIQIMPOIT, VRREDBCIMPOIT, VRIMPOSIT,
                   VRBCALCIMPOIT, NRSEQITPRO)

               VALUES(
                      C_NOTA.CDFILIAL, C_NOTA.NRLANCTONF, C_ITEM.NRSEQITPROD, C_INCIDENCIA.CDIMPOTEMP, C_INCIDENCIA.CDFISCTEMP,
                      C_ITEM.VRTOTAITEM, 0, V_ALIQUTMP, V_PREDBCTMP, 0,
                      C_ITEM.VRTOTAITEM, '1');

            DELETE ALIQTEMP
            WHERE NRALIQTEMP = V_ALIQTEMP;
         END LOOP;
      END LOOP;

      FOR C_IMPOSNFTOT IN (
          SELECT IP.CDIMPOSTOIT AS CDIMPOSTO,  SUM(ROUND(NVL(VRIMPOSIT,0),2)) AS VRIMPOSTOIT,
                 NVL(SUM(VRBCALCIMPOIT),0) AS VRBASECALCIT
            FROM TRABITPROIMPOS IP, IMPOSTO I
           WHERE (IP.CDFILIMPOIT     = C_NOTA.CDFILIAL)       AND
                 (IP.NRLANCIMPOIT    = C_NOTA.NRLANCTONF)     AND
                 (I.CDIMPOSTO        = IP.CDIMPOSTOIT)
           GROUP BY IP.CDIMPOSTOIT) LOOP

          DELETE FROM TRABIMPOSNFTOT
           WHERE CDFILIMPTOT   = C_NOTA.CDFILIAL   AND
                 NRLANCIMPTOT  = C_NOTA.NRLANCTONF AND
                 CDIMPOSTOT    = C_IMPOSNFTOT.CDIMPOSTO;

          INSERT INTO TRABIMPOSNFTOT(
                 CDFILIMPTOT,  NRLANCIMPTOT, CDIMPOSTOT,
                 VRIMPOSTOT, VRBCALIMPTOT)
          VALUES (
                 C_NOTA.CDFILIAL, C_NOTA.NRLANCTONF,C_IMPOSNFTOT.CDIMPOSTO,
                 NVL(C_IMPOSNFTOT.VRIMPOSTOIT,0), NVL(C_IMPOSNFTOT.VRBASECALCIT,0));
      END LOOP;

      DELETE INCITEMP
       WHERE NRINCITEMP = V_INCITEMP;

      IMPOSTO_ENTRADA(C_NOTA.CDEMPRESA, C_NOTA.CDINSCESTA,C_NOTA.CDTIPOOPER, C_NOTA.CDFORNECED,C_NOTA.CDFILIAL, C_NOTA.NRLANCTONF, C_NOTA.DTENTRSAID, V_VRNOTAFISC,P_NRLANCESTQ,'E', NULL);

      GRAVA_IMPOSTO(C_NOTA.CDFILIAL, C_NOTA.NRLANCTONF);
      COMMIT;
      P_VRNOTAFISC := V_VRNOTAFISC;
   END LOOP;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LSG_TRAB_IMPOSTO_ENTRADA','5.42.000'); END;
/
